
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  25. May 2006  14:58  *************

	processor  16F628
	radix  DEC

	__config 0x3F18

TMR0        EQU   0x01
STATUS      EQU   0x03
PORTA       EQU   0x05
TRISA       EQU   0x85
TRISB       EQU   0x86
INTCON      EQU   0x0B
INTEDG      EQU   6
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
INTF        EQU   1
T0IF        EQU   2
INTE        EQU   4
GIE         EQU   7
OPTION_REG  EQU   0x81
T1CON       EQU   0x10
CMCON       EQU   0x1F
EEDATA      EQU   0x9A
EEADR       EQU   0x9B
EECON2      EQU   0x9D
RA0         EQU   0
RA1         EQU   1
RA2         EQU   2
RA3         EQU   3
RA4         EQU   4
RA5         EQU   5
RA6         EQU   6
RA7         EQU   7
RB1         EQU   1
RB2         EQU   2
RB3         EQU   3
RB4         EQU   4
RB5         EQU   5
RB6         EQU   6
EEIF        EQU   7
TRISA0      EQU   0
TRISA1      EQU   1
TRISA2      EQU   2
TRISA3      EQU   3
TRISA4      EQU   4
TRISA5      EQU   5
TRISA6      EQU   6
TRISA7      EQU   7
RD          EQU   0
WR          EQU   1
WREN        EQU   2
key_state   EQU   0x26
key_press   EQU   0x27
key_collected EQU   0x28
ircode      EQU   0x29
irled       EQU   0x2B
old_ircode  EQU   0x2C
nachlauf    EQU   0x2D
sperrzeit   EQU   0x2E
tmr0cpy     EQU   0x2F
irledn      EQU   0
svrWREG     EQU   0x70
svrSTATUS   EQU   0x20
adr         EQU   0x22
data        EQU   0x23
prev_gie    EQU   0
adr_2       EQU   0x23
ct0         EQU   0x30
ct1         EQU   0x31
i           EQU   0x22
tester      EQU   0x22
temp        EQU   0x22
i_2         EQU   0x23
t           EQU   0x24
t_2         EQU   0x24
i_3         EQU   0x25
ton         EQU   0x22
toff        EQU   0x23
h           EQU   0x22
C1cnt       EQU   0x23
tmp         EQU   0x21

	GOTO main

  ; FILE E:\projekte\picsel\source\picsel.c
			;/* PICSEL Version 1.4                             */
			;/* (c) C.Schirp  released for non-commercial use  */
			;/* IR-routines copyright by Jos van Eijndhoven    */
			;/* debouncing copyright by Peter Dannegger        */
			;/*                                                */
			;/* V1.3->V1.4: Tape-Relais ausblenden, wenn       */
			;/*             Tape-Gruppe inaktiv                */
			;/*                                                */
			;/* V1.2->V1.3: FB-Tasten 5&6 umrangiert,Nachlauf  */
			;/*             verkrzt                           */
			;
			;
			;#include <E:\projekte\picsel\cc5\16F628.h>
			;#include <E:\projekte\picsel\cc5\int16CXX.h>
			;
			;#pragma config |= 0x3F18
			;
			;
			;/* Defines */
			;#define KEY_INPUT PORTA
			;#define RCLK	RB5
			;#define SCLK	RB2
			;#define SER 	RB1
			;#define M_DIR	RB4
			;#define M_PWM   RB3
			;
			;#define INPUT 1
			;#define OUTPUT 0
			;
			;#define NL_TIME 10;
			;#define SP_TIME 20;
			;
			;unsigned char key_state;	 //debounced and inverted key state:
			;unsigned char key_press;
			;unsigned char key_collected;
			;
			;uns16  ircode;
			;unsigned char irled; // 1 if light is on
			;unsigned char old_ircode;
			;unsigned char nachlauf;
			;unsigned char sperrzeit;
			;
			;unsigned char tmr0cpy;
			;
			;
			;//bit Monitor; // Shadow fuer PB6
			;
			;bit irledn     @ PORTB.0;
			;
			;/*------------------------------------------------------------------*/
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*                                                                  */
			;/*------------------------------------------------------------------*/
			;
			;
			;#pragma origin 4
	ORG 0x0004
			;interrupt int_server( void)
			;{
int_server
			;    int_save_registers    // W, STATUS (and PCLATH)
	MOVWF svrWREG
	SWAPF STATUS,W
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF svrSTATUS
			;
			;    if ( INTF)
	BTFSS 0x0B,INTF
	GOTO  m003
			;    {
			;        /* RB0/INT interrupt */
			;        irled.0 = !irledn;
	BSF   irled,0
	BTFSC 0x06,irledn
	BCF   irled,0
			;        INTF = 0;
	BCF   0x0B,INTF
			;        if (irled)     // request interrupt on next edge (up or down)
	MOVF  irled,1
	BTFSC 0x03,Zero_
	GOTO  m001
			;           INTEDG = 1; // if 1, then interrupt on rising edge
	BSF   0x03,RP0
	BSF   0x81,INTEDG
			;        else
	GOTO  m002
			;           INTEDG = 0; // is part of OPTION_REG, is 1 on reset
m001	BSF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x81,INTEDG
			;
			;        /* finish and restart TMR0 */
			;        tmr0cpy = TMR0;
m002	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  TMR0,W
	MOVWF tmr0cpy
			;        TMR0 = 0;
	CLRF  TMR0
			;        T0IF = 1; // end polling wait-loop, similar to TRM0 wraparound
	BSF   0x0B,T0IF
			;    }
			;
			;   /*
			;     NOTE: GIE is AUTOMATICALLY cleared on interrupt entry and set
			;           to 1 on exit (by RETFIE). Setting GIE to 1 inside the
			;           interrupt service routine will cause nested interrupts
			;           if an interrupt is pending. Too deep nesting may crash
			;           the program !
			;   */
			;
			;    int_restore_registers // W, STATUS (and PCLATH)
m003	BCF   0x03,RP0
	BCF   0x03,RP1
	SWAPF svrSTATUS,W
	MOVWF STATUS
	SWAPF svrWREG,1
	SWAPF svrWREG,W
			;}
	RETFIE
			;
			;/*------------------------------------------------------------------*/
			;/*   II  N   N  II TTTTT                                            */
			;/*   II  NN  N  II   T                                              */
			;/*   II  N N N  II   T                                              */
			;/*   II  N  NN  II   T                                              */
			;/*   II  N   N  II   T                                              */
			;/*------------------------------------------------------------------*/
			;
			;
			;void init ()
			;{
init
			;	/* PORT A Config */
			;	CMCON = 0x07;		// kein Komparator
	MOVLW .7
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF CMCON
			;	TRISA = 0xFF;		// alle input
	MOVLW .255
	BSF   0x03,RP0
	MOVWF TRISA
			;    PORTA = 0;			// alle low
	BCF   0x03,RP0
	CLRF  PORTA
			;
			;	/* PORT B Config */
			;	TRISB = 0b1000.0001;	// PB0,7 input, rest output
	MOVLW .129
	BSF   0x03,RP0
	MOVWF TRISB
			;	T1CON = 0x00;			// Timer disabled
	BCF   0x03,RP0
	CLRF  T1CON
			;	RB6 =   0;				// Monitor-LED high=aus
	BCF   0x06,RB6
			;
			;	RCLK = 0;				// seriell reset state
	BCF   0x06,RB5
			;	SCLK = 0;
	BCF   0x06,RB2
			;	SER  = 0;
	BCF   0x06,RB1
			;
			;	M_DIR = 0;				// Motorsignale
	BCF   0x06,RB4
			;	M_PWM = 0;
	BCF   0x06,RB3
			;
			;	/*sonstiges*/
			;	OPTION_REG = 0x04;/* pull-up portB, falling edge int, no WDT prescaler, prescale=32 */
	MOVLW .4
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;
			;
			;	/* Variablen initialisieren */
			;	key_state = 0xFF;
	MOVLW .255
	BCF   0x03,RP0
	MOVWF key_state
			;	//Monitor = 0;
			;	irled = 	0;
	CLRF  irled
			;	old_ircode= 0;
	CLRF  old_ircode
			;	nachlauf =  0;
	CLRF  nachlauf
			;
			;	INTCON = 0; 			// reset and disable all interrupts by default
	CLRF  INTCON
			;	INTE = 	1;
	BSF   0x0B,INTE
			;	GIE = 	 1;				// Enable Interrupts
	BSF   0x0B,GIE
			;}
	RETURN
			;
			;/*------------------------------------------------------------------*/
			;/*    EEEE  EEEE  PPPP   RRRR    OOO   M     M                      */
			;/*    E     E     P   P  R   R  O   O  MM   MM                      */
			;/*    EEE   EEE   PPPP   RRRR   O   O  M M M M                      */
			;/*    E     E     P      R R    O   O  M  M  M                      */
			;/*    EEEE  EEEE  P      R  R    OOO   M     M                      */
			;/*------------------------------------------------------------------*/
			;
			;
			;
			;void write_eeprom( unsigned char adr, unsigned char data)
			;{
write_eeprom
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF data
			;	bit prev_gie = GIE;
	BCF   0x24,prev_gie
	BTFSC 0x0B,GIE
	BSF   0x24,prev_gie
			;	GIE = 0; 		// disable interrupts
	BCF   0x0B,GIE
			;	EEIF = 0; 		// clear eprom interrupt flag
	BCF   0x0C,EEIF
			;
			;	while (WR)
m004	BSF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x9C,WR
	GOTO  m005
			;		; 			// wait if previous write is still busy
	GOTO  m004
			;
			;	EEADR = adr; 	// valid range is from 00h to 7Fh (128 bytes)
m005	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  adr,W
	BSF   0x03,RP0
	MOVWF EEADR
			;	EEADR &= 0x7f; 	// prevent bugs to overwrite program memory
	BCF   EEADR,7
			;	EEDATA = data;
	BCF   0x03,RP0
	MOVF  data,W
	BSF   0x03,RP0
	MOVWF EEDATA
			;	WREN = 1;
	BSF   0x9C,WREN
			;	EECON2 = 0x55;
	MOVLW .85
	MOVWF EECON2
			;	EECON2 = 0xAA;
	MOVLW .170
	MOVWF EECON2
			;	WR = 1; 		// start the actual write
	BSF   0x9C,WR
			;
			;	WREN = 0; 		// protect against unintended writes
	BCF   0x9C,WREN
			;	GIE = prev_gie; // restore interrupts
	BCF   0x03,RP0
	BTFSS 0x24,prev_gie
	BCF   0x0B,GIE
	BTFSC 0x24,prev_gie
	BSF   0x0B,GIE
			;}
	RETURN
			;
			;unsigned char read_eeprom( unsigned char adr)
			;{
read_eeprom
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF adr_2
			;	EEADR = adr; 	// valid range is from 00h to 7Fh (128 bytes)
	MOVF  adr_2,W
	BSF   0x03,RP0
	MOVWF EEADR
			;	EEADR &= 0x7f; 	// prevent bugs to exceed program memory
	BCF   EEADR,7
			;	RD = 1;
	BSF   0x9C,RD
			;	return EEDATA;
	MOVF  EEDATA,W
	RETURN
			;}
			;
			;/*------------------------------------------------------------------*/
			;/*    K  K  EEEE  Y   Y   SSS                                       */
			;/*    K K   E      Y Y   S                                          */
			;/*    KK    EE      Y     SSS                                       */
			;/*    K K   E       Y        S                                      */
			;/*    K  K  EEEE    Y     SSS                                       */
			;/*------------------------------------------------------------------*/
			;
			;
			;void debounce(void)
			;{
debounce
			;  static unsigned char ct0, ct1;
			;  unsigned char i;
			;
			;  i = key_state ^ ~KEY_INPUT;	// key changed ?
	BCF   0x03,RP0
	BCF   0x03,RP1
	COMF  PORTA,W
	XORWF key_state,W
	MOVWF i
			;  ct0 = ~( ct0 & i );			// reset or count ct0
	MOVF  i,W
	ANDWF ct0,W
	XORLW .255
	MOVWF ct0
			;  ct1 = ct0 ^ (ct1 & i);		// reset or count ct1
	MOVF  i,W
	ANDWF ct1,W
	XORWF ct0,W
	MOVWF ct1
			;  i &= ct0 & ct1;				// count until roll over
	MOVF  ct1,W
	ANDWF ct0,W
	ANDWF i,1
			;  key_state ^= i;				// then toggle debounced state
	MOVF  i,W
	XORWF key_state,1
			;  key_press |= key_state & i;	// 0->1: key pressing detect
	MOVF  i,W
	ANDWF key_state,W
	IORWF key_press,1
			;}
	RETURN
			;
			;
			;void do_keys(void)
			;{
do_keys
			;	switch (key_press)
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  key_press,W
	XORLW .1
	BTFSC 0x03,Zero_
	GOTO  m006
	XORLW .3
	BTFSC 0x03,Zero_
	GOTO  m007
	XORLW .6
	BTFSC 0x03,Zero_
	GOTO  m008
	XORLW .12
	BTFSC 0x03,Zero_
	GOTO  m009
	XORLW .24
	BTFSC 0x03,Zero_
	GOTO  m010
	XORLW .48
	BTFSC 0x03,Zero_
	GOTO  m011
	XORLW .96
	BTFSC 0x03,Zero_
	GOTO  m014
	XORLW .192
	BTFSC 0x03,Zero_
	GOTO  m015
	GOTO  m016
			;	{
			;	case 0x01:	RA0 = 0; TRISA0 = OUTPUT;
m006	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x05,RA0
	BSF   0x03,RP0
	BCF   0x85,TRISA0
			;				TRISA |= 0x0E; // TRISA 1,2,3 setzen
	MOVLW .14
	IORWF TRISA,1
			;				//TRISA1 = INPUT;
			;				//TRISA2 = INPUT;
			;				//TRISA3 = INPUT;
			;				break;
	GOTO  m017
			;	case 0x02:	RA1 = 0; TRISA1 = OUTPUT;
m007	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x05,RA1
	BSF   0x03,RP0
	BCF   0x85,TRISA1
			;				TRISA |= 0x0D; // TRISA 0,2,3 setzen
	MOVLW .13
	IORWF TRISA,1
			;				//TRISA0 = INPUT;
			;				//TRISA2 = INPUT;
			;				//TRISA3 = INPUT;
			;				break;
	GOTO  m017
			;	case 0x04:	RA2 = 0; TRISA2 = OUTPUT;
m008	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x05,RA2
	BSF   0x03,RP0
	BCF   0x85,TRISA2
			;				TRISA |= 0x0B; // TRISA 0,1,3 setzen
	MOVLW .11
	IORWF TRISA,1
			;				//TRISA0 = INPUT;
			;				//TRISA1 = INPUT;
			;				//TRISA3 = INPUT;
			;				break;
	GOTO  m017
			;	case 0x08:	RA3 = 0; TRISA3 = OUTPUT;
m009	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x05,RA3
	BSF   0x03,RP0
	BCF   0x85,TRISA3
			;				TRISA |= 0x07; // TRISA 0,1,2 setzen
	MOVLW .7
	IORWF TRISA,1
			;				//TRISA0 = INPUT;
			;				//TRISA1 = INPUT;
			;				//TRISA2 = INPUT;
			;				break;
	GOTO  m017
			;	case 0x10:	RA4 = 0; TRISA4 = OUTPUT;
m010	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x05,RA4
	BSF   0x03,RP0
	BCF   0x85,TRISA4
			;				TRISA7 = INPUT;
	BSF   0x85,TRISA7
			;				TRISA6 = INPUT;
	BSF   0x85,TRISA6
			;				break;
	GOTO  m017
			;	case 0x20:	RA5 = 0; TRISA5 = INPUT;
m011	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x05,RA5
	BSF   0x03,RP0
	BSF   0x85,TRISA5
			;				if (RB6) // Monitor
	BCF   0x03,RP0
	BTFSS 0x06,RB6
	GOTO  m012
			;				{
			;					RB6 = 0;
	BCF   0x06,RB6
			;					//Monitor = 0;
			;				}
			;				else
	GOTO  m013
			;				{
			;					RB6 = 1;
m012	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   0x06,RB6
			;					//Monitor = 1;
			;				}
			;				break;
m013	GOTO  m017
			;	case 0x40:	RA6 = 0; TRISA6 = OUTPUT;
m014	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x05,RA6
	BSF   0x03,RP0
	BCF   0x85,TRISA6
			;				TRISA7 = INPUT;
	BSF   0x85,TRISA7
			;				TRISA4 = INPUT;
	BSF   0x85,TRISA4
			;				break;
	GOTO  m017
			;	case 0x80:	RA7 = 0; TRISA7 = OUTPUT;
m015	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x05,RA7
	BSF   0x03,RP0
	BCF   0x85,TRISA7
			;				TRISA6 = INPUT;
	BSF   0x85,TRISA6
			;				TRISA4 = INPUT;
	BSF   0x85,TRISA4
			;				break;
	GOTO  m017
			;	default: break;
m016	GOTO  m017
			;	}
			;
			;}
m017	RETURN
			;
			;void collect (void)
			;{
collect
			;	key_collected = TRISA;
	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVF  TRISA,W
	BCF   0x03,RP0
	MOVWF key_collected
			;
			;	if (!RB6) // Monitor
	BTFSC 0x06,RB6
	GOTO  m018
			;		key_collected &= 0xDF;
	BCF   key_collected,5
			;}
m018	RETURN
			;
			;void restore_state(void)
			;{
restore_state
			;	unsigned char tester;
			;
			;	key_collected = read_eeprom(0);
	MOVLW .0
	CALL  read_eeprom
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF key_collected
			;	tester = read_eeprom(1);
	MOVLW .1
	CALL  read_eeprom
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF tester
			;	key_press = read_eeprom(2);
	MOVLW .2
	CALL  read_eeprom
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF key_press
			;
			;	// 2 aus 3
			;	if (key_collected==tester)
	MOVF  key_collected,W
	XORWF tester,W
	BTFSS 0x03,Zero_
	GOTO  m019
			;	{
			;	}
			;	else if (key_collected==key_press)
	GOTO  m021
m019	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  key_collected,W
	XORWF key_press,W
	BTFSS 0x03,Zero_
	GOTO  m020
			;	{
			;	}
			;	else if (tester == key_press)
	GOTO  m021
m020	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tester,W
	XORWF key_press,W
	BTFSS 0x03,Zero_
	GOTO  m021
			;	{
			;		key_collected = tester;
	MOVF  tester,W
	MOVWF key_collected
			;	}
			;
			;	key_press = 0; // Variable initialisieren
m021	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  key_press
			;
			;	// gueltige Bitkombinationen fuer TAPE testen
			;	tester = key_collected;
	MOVF  key_collected,W
	MOVWF tester
			;	tester &= 0b1101.0000;
	MOVLW .208
	ANDWF tester,1
			;
			;	switch (tester)
	MOVF  tester,W
	XORLW .80
	BTFSC 0x03,Zero_
	GOTO  m022
	XORLW .192
	BTFSC 0x03,Zero_
	GOTO  m022
	XORLW .80
	BTFSC 0x03,Zero_
	GOTO  m022
	GOTO  m023
			;	{
			;		case 0b0101.0000:
			;		case 0b1001.0000:
			;		case 0b1100.0000: break;
m022	GOTO  m024
			;		default: key_collected |= 0b.1101.0000; break;
m023	MOVLW .208
	BCF   0x03,RP0
	BCF   0x03,RP1
	IORWF key_collected,1
	GOTO  m024
			;	}
			;
			;	// gueltige Bitkombinationen fuer Phono/CD/Tuner/AUX testen
			;	tester = key_collected;
m024	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  key_collected,W
	MOVWF tester
			;	tester &= 0b0000.1111;
	MOVLW .15
	ANDWF tester,1
			;
			;	switch (tester)
	MOVF  tester,W
	XORLW .7
	BTFSC 0x03,Zero_
	GOTO  m025
	XORLW .12
	BTFSC 0x03,Zero_
	GOTO  m025
	XORLW .6
	BTFSC 0x03,Zero_
	GOTO  m025
	XORLW .3
	BTFSC 0x03,Zero_
	GOTO  m025
	GOTO  m026
			;	{
			;		case 0b0000.0111:
			;		case 0b0000.1011:
			;		case 0b0000.1101:
			;		case 0b0000.1110: break;
m025	GOTO  m027
			;		default: key_collected |= 0b.0000.1111; break;
m026	MOVLW .15
	BCF   0x03,RP0
	BCF   0x03,RP1
	IORWF key_collected,1
	GOTO  m027
			;	}
			;
			;	// Tape/Monitor Port und Shadow setzen
			;	if (key_collected & 0x20)
m027	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS key_collected,5
	GOTO  m028
			;	{
			;		RB6 = 1;
	BSF   0x06,RB6
			;		//Monitor = 1;
			;	}
			;	else
	GOTO  m029
			;	{
			;		RB6 = 0;
m028	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x06,RB6
			;		//Monitor = 0;
			;	}
			;
			;	key_state = ~key_collected;
m029	BCF   0x03,RP0
	BCF   0x03,RP1
	COMF  key_collected,W
	MOVWF key_state
			;
			;	// Tape/Monitor-Bit setzen (immer Eingang!)
			;	key_collected |= 0x20;
	BSF   key_collected,5
			;
			;	TRISA = key_collected;
	MOVF  key_collected,W
	BSF   0x03,RP0
	MOVWF TRISA
			;}
	RETURN
			;
			;void set_relais(void)
			;{
set_relais
			;
			;	unsigned char temp;
			;	unsigned char i;
			;
			;	temp = ~key_collected;
	BCF   0x03,RP0
	BCF   0x03,RP1
	COMF  key_collected,W
	MOVWF temp
			;
			;	// kleiner Stromspartrick:
			;	// Wenn Tape/Monitor nicht aktiv ist, Tape-Relais-Bits ausblenden
			;	if (key_collected & 0x20)
	BTFSS key_collected,5
	GOTO  m030
			;	{
			;		temp &= 0b0010.1111;
	MOVLW .47
	ANDWF temp,1
			;	}
			;
			;
			;	// Bits per SW austoggeln
			;	for ( i = 0; i<8 ; i++)
m030	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  i_2
m031	MOVLW .8
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF i_2,W
	BTFSC 0x03,Carry
	GOTO  m034
			;	{
			;		SCLK = 0;
	BCF   0x06,RB2
			;
			;		// aktuelles Bit auf SER ausgeben
			;		if (temp & 0b0000.0001)
	BTFSS temp,0
	GOTO  m032
			;		{
			;			SER = 1;
	BSF   0x06,RB1
			;		}
			;		else
	GOTO  m033
			;		{
			;			SER = 0;
m032	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x06,RB1
			;		}
			;
			;		SCLK = 1;
m033	BCF   0x03,RP0
	BCF   0x03,RP1
	BSF   0x06,RB2
			;
			;		// naechstes Bit
			;		temp >>= 1;
	BCF   0x03,Carry
	RRF   temp,1
			;	}
	INCF  i_2,1
	GOTO  m031
			;
			;	// alles wieder auf Idle zurueck
			;	SCLK = 0;
m034	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x06,RB2
			;	SER  = 0;
	BCF   0x06,RB1
			;
			;	// D-Latch clock betaetigen
			;	RCLK = 1;
	BSF   0x06,RB5
			;	RCLK = 1;
	BSF   0x06,RB5
			;	RCLK = 0;
	BCF   0x06,RB5
			;}
	RETURN
			;
			;/*
			;void pause(unsigned char ms)	// ms Milisekunden warten (fosc=4MHz)
			;{
			;	while(ms)				// Schleife verlassen wenn ms=0 ist
			;	{
			;    	OPTION = 2; 		// Vorteiler auf 8 einstellen
			;    	TMR0 = 131; 		//  [256-131=125]: 125 * 8 = 1000 (=1ms)
			;    	while (TMR0);		// abwarten einer Milisekunde
			;    	ms--;				// "ms" mit jeder Milisekunde ernidrigen
			;    }
			;
			;    OPTION = 4; 			// Zustand fr TMRWAIT herstellen
			;}
			;*/
			;
			;/*------------------------------------------------------------------*/
			;/*    RRR    CCC    55555                                           */
			;/*    R  R  C   C   5                                               */
			;/*    RRR   C       5555                                            */
			;/*    R R   C   C       5                                           */
			;/*    R  R   CCC    5555                                            */
			;/*------------------------------------------------------------------*/
			;
			;// 4MHz crystal, 1MHz cycle time, TMR0 prescale=32: timer units of 32 usec.
			;// TRM0 expires at 8 msec.
			;
			;extern uns8 tmr0wait( void)
			;{
tmr0wait
			;	tmr0cpy = 0xff; // potential longest waiting time, reduced by irled
	MOVLW .255
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF tmr0cpy
			;	while (!T0IF) // wait for TMR0 wrap-around or IRled
m035	BTFSC 0x0B,T0IF
	GOTO  m036
			;		;
	GOTO  m035
			;
			;	T0IF = 0;
m036	BCF   0x0B,T0IF
			;	return tmr0cpy;
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  tmr0cpy,W
	RETURN
			;}
			;
			;void ir_bogus( void)
			;{
ir_bogus
			;	// just eat irled input, as long as we have fast pulses
			;	uns8 t;
			;
			;	t = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  t
			;	while (t < 200)
m037	MOVLW .200
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF t,W
	BTFSC 0x03,Carry
	GOTO  m038
			;	   t = tmr0wait();
	CALL  tmr0wait
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF t
	GOTO  m037
			;
			;	ircode = 0xffffL; // bogus code;
m038	MOVLW .255
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ircode
	MOVLW .255
	MOVWF ircode+1
			;}
	RETURN
			;
			;void ir_philips_rc5(void) // now assuming no 'extended' RC5, so S2==1
			;{
ir_philips_rc5
			;	// 1 is sequence dark,light:  2x 900us == 2x28
			;	// 0 is sequence light,dark:  2x 900us == 2x28
			;	// frame is: one,one,toggle,11xdata
			;	unsigned char t;
			;	unsigned char i;
			;
			;	t = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  t_2
			;	i = 0;
	CLRF  i_3
			;	ircode = 0L;
	CLRF  ircode
	CLRF  ircode+1
			;	// starting now in the 2nd (light) half S2
			;	while (t < 80)
m039	MOVLW .80
	BCF   0x03,RP0
	BCF   0x03,RP1
	SUBWF t_2,W
	BTFSC 0x03,Carry
	GOTO  m042
			;	{
			;	   // last half of current bit still to be measured, its timer is running
			;	   ircode <<=1; // insert current value
	BCF   0x03,Carry
	RLF   ircode,1
	RLF   ircode+1,1
			;	   if (irled) // irled input is active low
	MOVF  irled,1
	BTFSC 0x03,Zero_
	GOTO  m040
			;		   ircode.0 = 1;
	BSF   ircode,0
			;	   i++;
m040	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  i_3,1
			;
			;	   t = tmr0wait();
	CALL  tmr0wait
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF t_2
			;
			;	   if (t < 38) // new codebit is same as current, edge at bit boundary
	MOVLW .38
	SUBWF t_2,W
	BTFSC 0x03,Carry
	GOTO  m041
			;	   {
			;	   	  t=tmr0wait(); // skip first half of new bit
	CALL  tmr0wait
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF t_2
			;	   }
			;	}
m041	GOTO  m039
			;
			;	ircode.high8 &= 0x07; // clear start bits S2 and T
m042	MOVLW .7
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF ircode+1,1
			;
			;	if (i < 13)
	MOVLW .13
	SUBWF i_3,W
	BTFSC 0x03,Carry
	GOTO  m043
			;	{
			;		ircode = 0xffffL; // bogus
	MOVLW .255
	MOVWF ircode
	MOVLW .255
	MOVWF ircode+1
			;	}
			;}
m043	RETURN
			;
			;
			;void get_ir( void)
			;{
get_ir
			;	unsigned char ton;
			;	unsigned char toff;
			;
			;    ton = tmr0wait(); // measure first light
	CALL  tmr0wait
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF ton
			;	toff = tmr0wait(); // following first dark
	CALL  tmr0wait
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF toff
			;
			;    if (ton  > 20 && ton  < 36 &&  // nominal 900/32 = 28
	MOVLW .21
	SUBWF ton,W
	BTFSS 0x03,Carry
	GOTO  m044
	MOVLW .36
	SUBWF ton,W
	BTFSC 0x03,Carry
	GOTO  m044
			;        toff > 20 && toff < 36)  // nominal 900/32 = 28
	MOVLW .21
	SUBWF toff,W
	BTFSS 0x03,Carry
	GOTO  m044
	MOVLW .36
	SUBWF toff,W
	BTFSC 0x03,Carry
	GOTO  m044
			;    {
			;		ir_philips_rc5();
	CALL  ir_philips_rc5
			;	}
			;	else
	GOTO  m045
			;	{
			;		ir_bogus();
m044	GOTO  ir_bogus
			;	}
			;}
m045	RETURN
			;
			;void do_remote(void)
			;{
do_remote
			;	unsigned char h;
			;
			;
			;
			;	// systemadresse testen
			;	h = ircode.high8 & 0b.0000.0111;
	MOVLW .7
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF ircode+1,W
	MOVWF h
			;	if (h != 4)
	MOVF  h,W
	XORLW .4
	BTFSC 0x03,Zero_
	GOTO  m046
			;	{
			;		return;
	RETURN
			;	}
			;
			;	h = ircode.low8 & 0b.1100.0000;
m046	MOVLW .192
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF ircode,W
	MOVWF h
			;	if (h != 0)
	MOVF  h,1
	BTFSC 0x03,Zero_
	GOTO  m047
			;	{
			;		return;
	RETURN
			;	}
			;
			;	// okay, kommando gilt uns: Commando extrahieren
			;	h= ircode.low8 & 0b.0011.1111;
m047	MOVLW .63
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF ircode,W
	MOVWF h
			;
			;	// Quellenumschaltung nur bei neuem IR-Code
			;	if (h != old_ircode)
	MOVF  h,W
	XORWF old_ircode,W
	BTFSC 0x03,Zero_
	GOTO  m055
			;	{
			;		// Quellenwahltasten = 1..8
			;		if ((0<h) && (h<9))
	MOVF  h,1
	BTFSC 0x03,Zero_
	GOTO  m053
	MOVLW .9
	SUBWF h,W
	BTFSC 0x03,Carry
	GOTO  m053
			;		{
			;			// Tasten 5 und 6 tauschen
			;			if (5==h)
	MOVF  h,W
	XORLW .5
	BTFSS 0x03,Zero_
	GOTO  m048
			;			{
			;				h=6;
	MOVLW .6
	MOVWF h
			;			}
			;			else if (6==h)
	GOTO  m049
m048	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  h,W
	XORLW .6
	BTFSS 0x03,Zero_
	GOTO  m049
			;			{
			;				h=5;
	MOVLW .5
	MOVWF h
			;			}
			;
			;			h-=1;	// Taste 1 entspricht Bit 0
m049	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  h,1
			;			key_press = 1;
	MOVLW .1
	MOVWF key_press
			;			key_press <<= h;
	MOVF  h,W
	BTFSC 0x03,Zero_
	GOTO  m051
	MOVWF C1cnt
m050	BCF   0x03,Carry
	BCF   0x03,RP0
	BCF   0x03,RP1
	RLF   key_press,1
	DECFSZ C1cnt,1
	GOTO  m050
			;			h+=1;	// code wiederherstellen
m051	BCF   0x03,RP0
	BCF   0x03,RP1
	INCF  h,1
			;
			;			// Tasten 5 und 6 tauschen
			;			if (5==h)
	MOVF  h,W
	XORLW .5
	BTFSS 0x03,Zero_
	GOTO  m052
			;			{
			;				h=6;
	MOVLW .6
	MOVWF h
			;			}
			;			else if (6==h)
	GOTO  m053
m052	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  h,W
	XORLW .6
	BTFSS 0x03,Zero_
	GOTO  m053
			;			{
			;				h=5;
	MOVLW .5
	MOVWF h
			;			}
			;
			;		}
			;
			;		if (h == 16) // Volume +
m053	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  h,W
	XORLW .16
	BTFSS 0x03,Zero_
	GOTO  m054
			;		{
			;			M_DIR = 1;
	BSF   0x06,RB4
			;			M_PWM = 0;
	BCF   0x06,RB3
			;			nachlauf = NL_TIME;
	MOVLW .10
	MOVWF nachlauf
			;			sperrzeit = SP_TIME;
	MOVLW .20
	MOVWF sperrzeit
			;		}
			;		else if (h == 17) // Volume -
	GOTO  m055
m054	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  h,W
	XORLW .17
	BTFSS 0x03,Zero_
	GOTO  m055
			;		{
			;			M_DIR = 0;
	BCF   0x06,RB4
			;			M_PWM = 1;
	BSF   0x06,RB3
			;			nachlauf = NL_TIME;
	MOVLW .10
	MOVWF nachlauf
			;			sperrzeit = SP_TIME;
	MOVLW .20
	MOVWF sperrzeit
			;		}
			;
			;	}
			;
			;
			;
			;	old_ircode = h;
m055	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  h,W
	MOVWF old_ircode
			;
			;	// bei Taste
			;	if (h == 5)
	MOVF  h,W
	XORLW .5
	BTFSS 0x03,Zero_
	GOTO  m056
			;		sperrzeit = SP_TIME;
	MOVLW .20
	MOVWF sperrzeit
			;
			;}
m056	RETURN
			;
			;
			;/*------------------------------------------------------------------*/
			;/*     M     M    A    II  N   N                                    */
			;/*     MM   MM   A A   II  NN  N                                    */
			;/*     M M M M  A   A  II  N N N                                    */
			;/*     M  M  M  AAAAA  II  N  NN                                    */
			;/*     M     M  A   A  II  N   N                                    */
			;/*------------------------------------------------------------------*/
			;
			;void main (void)
			;{
main
			;	unsigned char tmp;
			;
			;	init();
	CALL  init
			;
			;	restore_state();
	CALL  restore_state
			;
			;	collect();
	CALL  collect
			;
			;	set_relais();
	CALL  set_relais
			;
			;	while (1)
			;	{
			;
			;		// Schalter lesen und entprellen
			;		debounce();
m057	CALL  debounce
			;
			;		// wenn Taste, dann EEPROM und Relais schreiben
			;		if (key_press)
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  key_press,1
	BTFSC 0x03,Zero_
	GOTO  m058
			;		{
			;			// Auswerten, LEDs setzen
			;			do_keys();
	CALL  do_keys
			;
			;			collect();
	CALL  collect
			;			write_eeprom(0,key_collected);
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  adr
	MOVF  key_collected,W
	CALL  write_eeprom
			;			write_eeprom(1,key_collected);
	MOVLW .1
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF adr
	MOVF  key_collected,W
	CALL  write_eeprom
			;			write_eeprom(2,key_collected);
	MOVLW .2
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF adr
	MOVF  key_collected,W
	CALL  write_eeprom
			;			set_relais();
	CALL  set_relais
			;		}
			;		// zustand zuruecksetzen
			;		key_press = 0;
m058	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  key_press
			;
			;		tmp = tmr0wait(); // wrap-around or interrupt, wrap-around takes 8ms
	CALL  tmr0wait
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF tmp
			;
			;		//pause(10);
			;
			;	    if (irled) //came out of wait by interrupt: light on, start of new code
	MOVF  irled,1
	BTFSC 0x03,Zero_
	GOTO  m059
			;		{
			;			get_ir();
	CALL  get_ir
			;			do_remote();
	CALL  do_remote
			;		}
			;
			;		// Motornachlauf?
			;		if (!nachlauf)
m059	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  nachlauf,1
	BTFSS 0x03,Zero_
	GOTO  m060
			;		{
			;			M_DIR = 0;	// Motor stoppen
	BCF   0x06,RB4
			;			M_PWM = 0;
	BCF   0x06,RB3
			;		}
			;		else
	GOTO  m061
			;		{
			;			nachlauf--;
m060	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  nachlauf,1
			;		}
			;
			;		// Sperrzeit fuer Taste 5 (tape/Monitor)
			;		if (!sperrzeit)
m061	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  sperrzeit,1
	BTFSS 0x03,Zero_
	GOTO  m062
			;		{
			;			old_ircode = 0; // Fuer Tape/Monitor
	CLRF  old_ircode
			;		}
			;		else
	GOTO  m063
			;		{
			;			sperrzeit--;
m062	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  sperrzeit,1
			;		}
			;
			;
			;
			;	} /* while (1) */
m063	GOTO  m057

	END


; *** KEY INFO ***

; 0x0004   33 word(s)  1 % : int_server
; 0x0025   33 word(s)  1 % : init
; 0x0046   36 word(s)  1 % : write_eeprom
; 0x006A   10 word(s)  0 % : read_eeprom
; 0x0074   22 word(s)  1 % : debounce
; 0x008A  100 word(s)  4 % : do_keys
; 0x00EE    9 word(s)  0 % : collect
; 0x00F7  103 word(s)  5 % : restore_state
; 0x015E   40 word(s)  1 % : set_relais
; 0x0186   12 word(s)  0 % : tmr0wait
; 0x0192   21 word(s)  1 % : ir_bogus
; 0x01A7   48 word(s)  2 % : ir_philips_rc5
; 0x01D7   28 word(s)  1 % : get_ir
; 0x01F3  119 word(s)  5 % : do_remote
; 0x026A   64 word(s)  3 % : main

; RAM usage: 19 bytes (7 local), 205 bytes free
; Maximum call level: 3 (+1 for interrupt)
; Total of 679 code words (33 %)
